/*

========
= Kiss =
========

version 1.0 (beta 7)

by Alex Chaffee

Reed College Box 259, Portland, OR 97202
Compuserve: 71210,1117
Internet: chaffee@reed.{uucp,bitnet} or chaffee%reed@tektronix.com
America Online: AlexCh

Copyright  1990 by Alex Chaffee.

Kiss may be freely distributed (with the limitations listed below), as
long as this document and copyright information remain attached;
however, if you decide to keep it, please send me a shareware fee of
$10 ($5 for students; contact me if you'd like a site license), or a
six-pack of your favorite local beer, or whatever you think it's
worth.  At the very least, send me a postcard. This is the first time
I've asked for shareware fees, because it's the first of my many
projects I've thought was worth it.  And if you don't pay, you don't
get new versions until everybody else has them too...

I grant permission for Kiss to be included in the libraries of on-line
services and bulletin boards which do not charge extra (that is, more
than their usual connect-time rates) for downloading time, in the
libraries of non-profit users' groups (including collections such as
the BMUG PD-ROM), and on public-access file servers.  Commercial 
distribution requires written permission from the author.

What It Is

Kiss is an INIT that modifies the THINK C 4.0 editor to provide several useful
features -- Word-Forward, Word-Backward, Page-Up, Page-Down, Home, End,
Forward-Delete, Delete-Word, Mark and Parenthesis Kissing (hence the name).  
Pressing Command or Option and the arrow keys do the first four, and the keys on 
the Extended ADB Keyboard will now do what you think they should.  You can also 
press shift and any of these to extend the selection.  (Extending the selection 
still doesn't use the "anchor point" idea like Real Mac word processors, but only 
makes the selection bigger; this is the way Think itself does it so I don't feel 
too guilty. I may find this annoying enough to fix in a future version.)

If you press ')', ']', or '}', Kiss will search backwards to find the matching
'(', '[', or '{', and briefly highlight it.  (If the mate is off the screen, you
will see nothing.)  If it can't find a mate, it will beep.  This feature treats
character and string constants correctly (i.e. <'{'> and <"\"">), and will not
get confused if you have unmatching parentheses or quotes inside a comment.

Pressing Command-Space ("Set Mark") saves the current selection as the Mark.  If
you press Command-Enter ("Jump To Mark"), Kiss will re-select the Mark and
scroll to it. Pressing Option-Enter ("Swap Mark") does both of these at once, so
that subsequent Swaps will bounce back and forth between the two selections.

Command Summary

	  Cmd- Up/Down	Page Up/Down
       PageUp/PageDown	Page Up/Down	
	  Opt- Up/Down	Home/End of File
	      Home/End	Home/End of File
       Cmd- Left/Right	Start/End of Line
       Opt- Left/Right	Previous/Next Word
	    Del/FwdDel	Delete Previous/Next Character
       Opt- Del/FwdDel	Delete Previous/Next Word
	       ), }, ]	Kiss
	    Cmd- Space	Set Mark
	    Cmd- Enter	Jump To Mark
	    Opt- Enter	Swap Mark and Selection
	
What It Isn't

Kiss may not be perfect.  Please tell me whatever bugs you find.  If you're a
registered (i.e. paid) user, I'll send you a copy of the latest version as it's
written.  Until I get it out of the beta stages (any day now!), I plan to 
distribute new versions only through Compuserve, America Online, and E-Mail.  
If you don't have access to these, please tell me, and I'll send you a copy of 
the final version as soon as it's finished.

And of course, Kiss may be improved.  If you have any suggestions on things
you'd like Think to do, send them along and I'll think about them.  I may soon
make Kiss a cdev, so you can disable or modify some of the features.  Actually,
I've got an idea to write a cdev/INIT which will take the idea of Kiss to its
limit and allow other programmers to write their own plug-in CODE resources to
extend Think's editor.  If you'd like to brainstorm with me about this, please
write (preferably via the Internet or Compuserve).

Just In Case

THINK C is a trademark of Symantec Corporation.

Known Bugs

	If the selection range extends more than one page away, Page-up and 
	page-down only scroll one page, regardless of the actual
	distance to the top or bottom of the new selection.
	
	I should really implement multiple marks for multiple files.  As it
	stands, there's only one global mark, so if you set the mark in a new
	file, it forgets the mark in the old one.

	Forward-delete only supports one character of Undo.
	
Version History

2/24/90	Version 1.0 Beta 1 released
3/22	Beta 2 
	- Fixed screen update bugs
	- Kiss now ignores comments (but if you type a mismatched paren inside 
	  a comment, it'll match with one outside -- and it gets confused by 
	  more than one "/*" in a row -- got it?)
	- Word-forward and -backward off the screen now scroll properly
	- New icon
	- Incidentally, if you use FunKey, ask me for a new version which is
	  fully compatible with Kiss.
3/28	Beta 3
	- Fixed problem with kissing at the very beginning of the file
	- Added Mark, added STR 128
	- More screen update glitches fixed
5/18	Beta 4
	- Now your copy of Think can be named anything you want
7/16	Beta 5
	- Changed keys around to match Apple's guidelines: Next/Previous Word 
	  is now Option-Right/Left
	- Added End/Start of Line (Command-Right/Left)
	- Finally squashed the Cancel-Click-Bus Error bug
7/24	Beta 6
	- Added Delete Word (Opt-Del/FwdDel)
9/10	Beta 7
	- Fixed a stupid-ass bug that caused a fatal crash which, for some
	  strange reason, I never encountered personally.
*/
